
browser.runtime.onMessage.addListener((request, sender, sendResponse) => {
  if (request.command === 'showSourceText') {
    document.getElementById('source-text-content').textContent = request.sourceText;
    document.getElementById('recognized-terms-content').textContent = '';
  }

  if (request.command === 'showRecognizedTerms') {
    let alertClass = request.MCPRecognizedTerms.startsWith('<p class="mcp-error">') ? 'alert-danger' : 'alert-success';
    document.getElementById('recognized-terms').setAttribute('class',  `alert ${alertClass}`);
    document.getElementById('recognized-terms-content').innerHTML = request.MCPRecognizedTerms;
    // INNERHTML ON ABOVE LINE IS NOT UNSAFE BECAUSE IT NOT INJECT ANY USER INPUT.
    // BUT, IN CASE OF VALIDATION PROBLEM, COMMENTED BELOW IS A WORKAROUND BASED ON
    // https://devtidbits.com/2017/12/06/quick-fix-the-unsafe_var_assignment-warning-in-javascript/
    // for (const tag of getSanitizedHTML(request.MCPRecognizedTerms)) {
    //     document.getElementById('recognized-terms-content').appendChild(tag);
    // };


    var tooltipTriggerList = [].slice.call(document.querySelectorAll('[data-bs-toggle="tooltip"]'))
    tooltipTriggerList.map(function (tooltipTriggerEl) {
        return new bootstrap.Tooltip(tooltipTriggerEl)
    })

    let clipboard = new ClipboardJS('[data-clipboard-text]');
      clipboard.on('success', function(e) {
          e.trigger.dataset.bsOriginalTitle = 'Copied!';
          let tooltipEl = bootstrap.Tooltip.getInstance(e.trigger);
          tooltipEl.show();
          e.trigger.dataset.bsOriginalTitle = 'Click to copy';
          e.clearSelection();
      });
  }
});

document.querySelector('#unlock-textfields').addEventListener('click', function(e){
	e.preventDefault();
	browser.tabs.query({currentWindow: true, active: true }).then(
	  tabs => browser.tabs.sendMessage(tabs[0].id, {command: 'unlockTextfields'})
	);
});

/*
function getSanitizedHTML(rawHTML) {
    rawHTML = `<div>${rawHTML}</div>`;
    const parser = new DOMParser();
    const parsed = parser.parseFromString(rawHTML, 'text/html');
    const sanitizedHTML = parsed.getElementsByTagName('div');
    return sanitizedHTML;
}
*/
